/*! (c)2017 AppNexus, Inc. v1.0.6
This code contains portions of Video.js modified by AppNexus. Video.js is Copyright Brightcove, Inc. and Licensed under the Apache License, Version 2.0 (the “License”); you may not use Video.js except in compliance with the License. You may obtain a copy of the License at
http://www.apache.org/licenses/LICENSE-2.0
Unless required by applicable law or agreed in writing, software distributed under the License is distributed on an “AS IS” BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.
Apache License, Version 2.0
TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
1. Definitions.
"License" shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document.
"Licensor" shall mean the copyright owner or entity authorized by the copyright owner that is granting the License.
"Legal Entity" shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, "control" means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity.
"You" (or "Your") shall mean an individual or Legal Entity exercising permissions granted by this License.
"Source" form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files.
"Object" form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types.
"Work" shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below).
"Derivative Works" shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof.
"Contribution" shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, "submitted" means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as "Not a Contribution."
"Contributor" shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work.
2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form.
3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed.
4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions:
a. You must give any other recipients of the Work or Derivative Works a copy of this License; and
b. You must cause any modified files to carry prominent notices stating that You changed the files; and
c. You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and
d. If the Work includes a "NOTICE" text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License.

You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License.
5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions.
6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file.
7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License.
8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages.
9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability.

This code contains portions of videojs-vast-plugin which is licensed under the MIT License.
The MIT License (MIT)
Copyright (c) 2015 MailOnline
Permission is here by granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
var APNVideo_AstMediationManager=function(e){function r(n){if(t[n])return t[n].exports;var a=t[n]={exports:{},id:n,loaded:!1};return e[n].call(a.exports,a,a.exports,r),a.loaded=!0,a.exports}var t={};return r.m=e,r.c=t,r.p="",r(0)}([function(e,r,t){function n(e,r){if(e.hasOwnProperty("cacheTTL")){var t=e.cacheTTL;t&&(L.debug("Setting cache ttl = "+t,C),M.setTimeToLive(t),t!==F&&F===A&&(F=t),X=!0)}if(X||(M.setTimeToLive(F),L.debug("Setting cache ttl = "+F,C),X=!0),e.hasOwnProperty("mediationTimeout")){var n=e.mediationTimeout;n&&(null!==r&&(U[r]=n,L.debug("setting mediation timeout ="+n,C)),n!==D&&D===T&&(D=n),j=!0)}}function a(e,r,t,a){L.debug("select ad requested: "+e,C);var u=o(r);if(t||(t={}),r&&null!==r&&u!==-1&&r.hasOwnProperty("ads")){var l="AST-TOKEN-"+M.getNextAdToken();L.debug("ad token created for impbus response="+l,C);var c={};c.callback=a,c.options=t,c.adId=e,c.uuid=u,c.tagData=r,c.astResponse=i(r),J[l]=c,n(t,e);var d=s(r,e,l,V,N,t);J[l].impbusData=d,null!==d&&p(d,V,e,l,N,t)}else{L.debug("ERROR: Invalid tag data received with selectAd request for: "+e+", uuid="+u+", data="+JSON.stringify(r),C);var f="Invalid ad request: ",v={};r&&null!==r?(v=i(r),f+=u===-1?"uuid is missing":"ads array is missing"):f+="tag element is null",y(e,u,a,v,f)}}function o(e){var r=-1;return e&&null!==e&&e.hasOwnProperty("uuid")&&(r=e.uuid),r}function i(e){var r={};for(var t in e)"ads"!==t&&(r[t]=e[t]);return r.ad=null,r}function s(e,r,t,n,a,o){if(L.debug("**** IMPBUS RESPONSE: RENDER="+a+" resp="+e+", adId="+r+" responseType="+n,C),e&&o){var i=E;o.hasOwnProperty("enableWaterfall")&&o.enableWaterfall===!1&&(i=!1),e.waterfall=i;var s=-1;o.hasOwnProperty("mediationTimeout")?s=o.mediationTimeout:u(e)||(s=w),s>-1&&(e[k]=s),null===q&&o.hasOwnProperty("pageNotificationCallback")&&o.pageNotificationCallback&&"function"==typeof o.pageNotificationCallback&&(q=o.pageNotificationCallback),l(e,t)}return e}function u(e){var r=!1,t=null;return e.hasOwnProperty(k)&&(t=e[k],t&&(r=!0)),r}function l(e,r){if(e){var t=r,n=0,a="";if(e.adToken=r,q&&(e.returnAdToken=!0),e.hasOwnProperty("no_ad_url")&&(a=e.no_ad_url,L.isNotEmpty(a)&&(P.addMediationTrackingEvent("no-ad",r,a,r),P.markAsMediationImpressionEvent("no-ad",!0,r,r))),e.hasOwnProperty("ads")){var o=e.ads;if(L.isNotEmpty(o))for(var i=0;i<o.length;i++){var s=o[i];if(s){n++;var u=t+"_"+n;if(s.hasOwnProperty("creative_id")){var l=""+s.creative_id;L.isNotEmpty(l)&&(u+=">creative-"+l)}if(s.name=u,a="",s.hasOwnProperty("content_source")){var c=s.content_source;if(s.hasOwnProperty(c)){var p=s[c];p.hasOwnProperty("request_url")&&(a=p.request_url,d(a,"ad-request",r,u,_)),p.hasOwnProperty("response_url")&&(a=p.response_url,d(a,"ad-response",r,u,_))}s.hasOwnProperty("notify_url")&&(a=s.notify_url,d(a,"ad-selection",r,u,_))}}}}}}function c(e,r){return r+">>"+e}function d(e,r,t,n,a){if(L.isNotEmpty(e)){var o=c(r,t);P.addMediationTrackingEvent(o,n,e,t),P.markAsMediationImpressionEvent(o,a,n,t)}}function p(e,r,t,n,a,o){var i=0;e.hasOwnProperty("timeout_ms")&&(i=e.timeout_ms),L.debug("startMediation, id: "+t+", timeout="+i+" token="+n+" responseType="+r+", renderAd="+a,C),L.debug("impbus response: "+JSON.stringify(e),C),R.processMediationSources(e,t,r,function(e,r,t){var o=n,i=a;f(e,r,t,o,i)},v,o)}function f(e,r,t,n,a){if(null!==r)switch(e){case V:g(r,n);break;case O:case S:m(t,n,"unexpected response type: "+e)}else L.debug("No ad was returned from mediation for: "+t+", renderAd="+a,C),h(n)}function v(e,r,t,n){r=c(r,e),P.requestMediationTracking(r,t,n,e),q&&q(e,r,t,n)}function g(e,r){if(J.hasOwnProperty(r)){var t=J[r],n=t.callback;if(n){var a=t.adId,o=t.uuid,i=t.astResponse;i.ad=e,L.debug("AST NOTIFICATION: Ad Selection for: "+a+", uuid="+o+" adToken="+r,C),n(a,o,i)}else L.debug("ERROR for AST NOTIFICATION: Ad Selection - missing callback for token: "+r,C)}else L.debug("PROGRAMMER ERROR - cannot find data for token: "+r,C)}function h(e){if(J.hasOwnProperty(e)){var r=J[e],t=r.callback;if(t){var n=r.adId,a=r.uuid,o=r.astResponse;o.ad=null,L.debug("AST NOTIFICATION: NO AD for: "+n+", uuid="+a+" adToken="+e,C),t(n,a,o)}else L.debug("ERROR for AST NOTIFICATION: Ad Selection - missing callback for token: "+e,C)}else L.debug("PROGRAMMER ERROR - cannot find data for token: "+e,C)}function m(e,r,t){if(J.hasOwnProperty(r)){var n=J[r],a=n.uuid,o=n.callback,i=n.astResponse;L.debug("MEDIATION FAILURE: for ad Id="+e+", tag id="+a+", reason="+t,C),y(e,a,o,i,t)}else L.debug("PROGRAMMER ERROR: cannot locate AST request for token="+r)}function y(e,r,t,n,a){L.debug("Notifying AST: invalid impbus data for: "+e+", uuid="+r,C),t?(null===n&&(n={}),n.ad={error:a},t(e,r,n)):L.debug("ERROR: AST callback is null for: "+e)}var b=1.5,w=1e3*b,T=-1,A=120,k="timeout_ms",N=!0,E=!0,_=!0,O=0,S=1,V=2,I="AST VIDEO MEDIATION MANAGER: ",x="VERSION 1.0.6",C="AMM",P=t(1),M=t(5),L=t(4),R=t(6),D=T,U={},F=A,X=!1,j=!1,J={},q=null;L.debug(I+x,C),e.exports={selectAd:function(e,r,t,n){a(e,r,t,n)}}},function(e,r,t){function n(){V={}}function a(e,r){V||(V={}),r=r||E,V[r]||(V[r]={});var t={};t.isImpression=!1,t.reportOnce=!0,t.reported=!1,t.urls=[],V[r][e]=t,O.debug("tracking data created, adId="+r+", event="+e,S)}function o(e){var r=e;switch(e){case"impressionUrls":r="impression";break;case"clickTrackingUrls":case"click":r="ad-click";break;case"errorUrls":r="error";break;case"imp_tracking_url":r="bid-impression";break;case"init_cb":r="ad-request";break;case"result_cb":r="ad-response";break;case"start":r="video-start";break;case"firstQuartile":r="video-first-quartile";break;case"midpoint":r="video-mid";break;case"thirdQuartile":r="video-third-quartile";break;case"thirdQuartile":r="video-third-quartile";break;case"complete":r="video-complete";break;case"unmute":r="audio-unmute";break;case"mute":r="audio-mute";break;case"pause":r="video-pause";break;case"rewind":r="video-rewind";break;case"resume":r="video-resume";break;case"fullscreen":r="video-fullscreen";break;case"exitFullscreen":r="video-exit-fullscreen";break;case"creativeView":r="creative-view";break;case"expand":r="ad-expand";break;case"collapse":r="ad-collapse";break;case"acceptInvitation":r="user-accept-invitation";break;case"close":r="user-close";break;case"progress":r="ad-progress";break;case"skip":r="video-skip"}return r}function i(e,r,t){t=t||E,e=o(e),V.hasOwnProperty(t)&&V[t].hasOwnProperty(e)||a(e,t),V[t][e].urls.push(r),O.debug("Tracking added, adId="+t+", event="+e+", url="+r,S)}function s(e,r){var t="";return O.isNotEmpty(e)&&O.isNotEmpty(r)&&(e=o(e),t=e+"_"+r),t}function u(e,r){r=r||E;var t=!1,n=V[r][e];return n&&n.hasOwnProperty("isImpression")&&(t=n.isImpression===!0),t}function l(e,r,t){if(t=t||E,O.isNotEmpty(e)){V.hasOwnProperty(t)&&V[t].hasOwnProperty(e)||a(e,t);var n=V[t][e];n.reportOnce=r,O.debug("setting report once, adId="+t+", event="+e+", setting="+r,S)}}function c(e,r,t,n){if(n=n||E,O.isNotEmpty(e)){e=o(e),O.isNotEmpty(t)&&(e=s(e,t)),V.hasOwnProperty(n)&&V[n].hasOwnProperty(e)||a(e,n);var i=V[n][e];i.reportOnce=r,O.debug("setting report once, adId="+n+", event="+e+", setting="+r,S)}}function d(e,r){if(r=r||E,V&&V.hasOwnProperty(r)){var t=V[r];for(var n in t)if(u(n,r)&&!e)O.debug("reset history skipping impression event="+n+", adId="+r,S);else{var a=V[r][n];a.reported=!1,O.debug("reset history for adId= "+r+", event="+n,S)}}}function p(e,r,t){t=t||E,e=o(e),V.hasOwnProperty(t)&&V[t].hasOwnProperty(e)||a(e,t),V[t][e].isImpression=r}function f(e,r,t){t=t||E;var n=!1;if(V.hasOwnProperty(t)&&V[t].hasOwnProperty(e)){var a=V[t][e];if(a)if(a.reportOnce&&a.reported)O.debug("Cannot report event - event has already been reported: "+e+" for adId="+t,S),n=!0;else{var o=a.urls;if(o){a.reported=!0;for(var i=0;i<o.length;i++){var s=o[i];O.isNotEmpty(s)&&(n=!0,r&&(s=b(s,r)),g(s,e))}}}}n||O.debug("No tracking urls found for adId="+t+", event = "+e,S)}function v(e,r,t,n){var a=s(e,r),o=h(t);f(a,o,n)}function g(e,r){O.debug("requesting tracking for "+r+", url="+e,S),_.trackPixel(e,r)}function h(e){O.debug("Creating params for mediation tracking from obj: "+O.objectToString(e),S);var r={},t="";if(e)for(var n in e)if(null!==e[n]&&"undefined"!==e[n]){t.length>0&&(t+="&");var a=n+"="+e[n];t+=a}return r.value=t,r}function m(e,r){var t=e,n="?";return e.indexOf("?")>-1&&(n="&"),t=e+n+r}function y(e,r,t){var n=e;return e.indexOf(t)>-1&&(n=e.replace(t,r)),n}function b(e,r){if(r){var t=r.value;if(O.isNotEmpty(t)){var n=r.macro;O.isNotEmpty(n)?e.indexOf(n)>-1&&(e=y(e,t,n)):e=m(e,t)}}return e}function w(e){return"progress>"+e}function T(e,r){if(r=r||E,V&&V.hasOwnProperty(r)){var t=V[r];for(var n in t)n.indexOf(e)>-1&&(delete V[r][n],O.debug("Removing event: "+n+" for key="+e+" and adId="+r,S));0===V[r].length&&delete V[r]}}function A(e){if(e=e||E,V&&V.hasOwnProperty(e)){var r=V[e];delete V[e];for(var t in r)O.debug("Removing event: "+t+" for adId="+e,S)}}var k=1,N="[ERRORCODE]",E="AN_DEFAULT",_=t(2),O=t(4),S="TM",V={};e.exports={init:function(e,r){if(A(r),e)for(var t=0;t<e.length;t++)l(e[t],!1,r)},addTrackingEvent:function(e,r,t){i(e,r,t)},addTrackingEvents:function(e,r){if(e)for(var t in e){var n=e[t];if(O.isNotEmpty(n))for(var a=0;a<n.length;a++)i(t,n[a],r)}},addMediationTrackingEvent:function(e,r,t,n){var a=s(e,r);O.debug("creating event name for adId="+(n?n:E)+", event="+e+", networkName="+r+" =>"+a,S),i(a,t,n)},addProgressTrackingEvent:function(e,r,t){var n=w(e);i(n,r,t)},markAsImpressionEvent:function(e,r,t){O.debug("marking event as impression: "+e+", adId="+(t?t:E)+", value="+r,S),p(e,r,t)},markAsMediationImpressionEvent:function(e,r,t,n){O.isNotEmpty(t)&&(e=s(e,t)),O.debug("marking event as impression: "+e+", adId="+(n?n:E)+", value="+r,S),p(e,r,n)},reportOnlyOnce:function(e,r,t){l(e,r,t)},reportMediationOnlyOnce:function(e,r,t,n){c(e,r,t,n)},resetTrackingHistory:function(e,r){d(e,r)},requestTracking:function(e,r){O.debug("tracking requested for "+e+", adId="+(r?r:E),S),f(e,null,r)},requestParamTracking:function(e,r,t){O.debug("tracking requested for "+e+" with param="+O.objectToString(r)+", adId="+(t?t:E),S),f(e,r,t)},requestMediationTracking:function(e,r,t,n){O.debug("tracking requested for mediation event: "+e+", network="+r+" , params="+O.objectToString(t)+", adId="+(n?n:E),S),v(e,r,t,n)},requestErrorTracking:function(e,r,t,n){O.debug("error reported: "+e+", type="+r+", desc="+t,NaN+(n?n:E),S);var a={},o="";switch(r){case k:a.macro=N,a.value=e,o="error";break;default:a.value="error="+e,o="error"}this.requestParamTracking(o,a,n)},requestProgressTracking:function(e,r){var t=w(e);O.debug("Tracking requested for progress event, adId="+(r?r:E)+", offset="+e,S),this.requestTracking(t,r)},removeEvents:function(e){A(e)},removeEventsForKey:function(e,r){T(e,r)},removeAllEvents:function(){n()}}},function(e,r,t){function n(e,r,a,o){var i,s=0,u=0,l=!1,c=t(4),d=t(5),p=!0,f=function(e){c.logDebug(e,"URL Loader")};if(o&&"undefined"!=typeof o.withCredentials&&(p=o.withCredentials),window.XMLHttpRequest)i=new XMLHttpRequest;else if(window.ActiveXObject)try{i=new ActiveXObject("Msxml2.XMLHTTP")}catch(v){try{i=new ActiveXObject("Microsoft.XMLHTTP")}catch(g){}}return i?(i.onreadystatechange=function(){if(4===i.readyState)if(200===i.status){if(r&&r.call(this,void 0,i.responseText,i),f("duration: "+u+", response length: "+i.responseText.length),l&&i.responseText&&i.responseText.length>2048){var e=8*i.responseText.length*1e3/(1024*Math.max(1,u)),t=parseInt(e.toString());f("Bandwidth: "+t);try{d.setGenericData("anxBandwidth",t)}catch(n){}}}else i.status>=400&&i.status<600&&r&&r.call(this,i.status,"",i);else 2===i.readyState?s=(new Date).getTime():3===i.readyState&&s>0&&(l=!0,u=(new Date).getTime()-s)},i.onerror=function(){if(p){var t=o?o:{};t.withCredentials=!1,n(e,r,a,t)}else if(r){var s=0===i.status?"404":i.status.toString();r.call(this,s,"",i)}},i.ontimeout=function(){r&&r.call(this,"Timeout","",i)},i.open("GET",e),a&&(i.timeout=a),i.withCredentials=p,s=0,void i.send()):void(r&&r.call(this,"406",""))}function a(e,r){o.log("Logging Event: "+r+" at url:"+e),new Image(1,1).src=e}var o=t(3);e.exports={load:function(e,r,t){n(e,r,t,{withCredentials:!0})},trackPixel:function(e,r){a(e,r)}}},function(e,r){function t(e){switch(e){case 0:break;case 1:return"always";case 2:return"error";case 3:return"warn";case 4:return"info";case 5:return"log";case 6:return"debug";case 7:return"verbose"}}function n(e,r){try{if("undefined"!=typeof e&&u(e)&&console){var n="[APN",a=t(e);if(console[a]||(n+="-"+a,a="log"),n+="]",r.splice(0,0,n),console[a].apply)console[a].apply(console,r);else{var o=Array.prototype.slice.apply(r).join("");console[a](o)}}}catch(i){}}function a(e){try{var r="";try{r=window.top.location.search}catch(t){try{r=window.location.search}catch(t){}}var n="[\\?&]"+e+"=([^&#]*)",a=new RegExp(n),o=a.exec(r);return null===o?"":decodeURIComponent(o[1].replace(/\+/g," "))}catch(t){return""}}function o(e){var r=w;try{if("undefined"!=typeof e){var t=parseInt(e);isNaN(t)?"boolean"==typeof e?r=e?b:d:(e=e.toUpperCase(),"TRUE"===e?r=b:"FALSE"===e&&(r=d)):r=t}}catch(n){}return r}function i(){try{T=o(a("ast_debug").toUpperCase()),c=Math.max(T,A)}catch(e){}}function s(e){try{A=o(e),c=Math.max(T,A)}catch(r){}}function u(e){return e<=c}function l(e,r,t){try{var n="[APN-"+e+"-"+(new Date).toISOString()+"] ";null!==t&&t&&t.length>0&&(n+=t+">"),n+=r,u(e)&&console.log(n)}catch(a){u(e)&&console.log(a)}}var c,d=0,p=1,f=2,v=3,g=4,h=5,m=6,y=6,b=m,w=d,T=w,A=w;e.exports={traceAtLevel:function(){try{if(arguments.length>0){var e=arguments[0],r=Array.prototype.slice.call(arguments,1);n.call(this,e,r)}}catch(t){}},always:function(){try{n.call(this,p,Array.prototype.slice.call(arguments))}catch(e){}},error:function(){try{n.call(this,f,Array.prototype.slice.call(arguments))}catch(e){}},log:function(){try{n.call(this,h,Array.prototype.slice.call(arguments))}catch(e){}},warn:function(){try{n.call(this,v,Array.prototype.slice.call(arguments))}catch(e){}},info:function(){try{n.call(this,g,Array.prototype.slice.call(arguments))}catch(e){}},debug:function(){try{n.call(this,m,Array.prototype.slice.call(arguments))}catch(e){}},verbose:function(){try{n.call(this,y,Array.prototype.slice.call(arguments))}catch(e){}},handleLogDebugLegacySupport:function(e,r){try{l(h,e,r)}catch(t){}},setDebugLevel:function(e){try{s(e)}catch(r){}},isTraceLevelActive:function(e){try{return u(e)}catch(r){return!1}},TRACE_LEVEL_ALWAYS:p,TRACE_LEVEL_ERROR:f,TRACE_LEVEL_WARN:v,TRACE_LEVEL_INFO:g,TRACE_LEVEL_LOG:h,TRACE_LEVEL_DEBUG:m,TRACE_LEVEL_VERBOSE:y},i()},function(e,r,t){function n(e){if(e)return e.responseXML?e.responseXML:e.responseText}var a=t(3),o=9;e.exports={debug:function(){a.handleLogDebugLegacySupport.apply(this,arguments)},logDebug:function(){a.handleLogDebugLegacySupport.apply(this,arguments)},setDebugLevel:function(e){a.setDebugLevel(e)},isNotEmpty:function(e){var r=!1;return null!==e&&e&&(r=e.length>0),r},objectToString:function(e,r){var t="null";if(r="undefined"!=typeof r?r:0,null!==e){t="OBJ[";var n="";for(var a in e){var i=e[a];if("object"==typeof i)if(r++,r<o)try{i=this.objectToString(i)}catch(s){i="err:"+s}else i="err: max recursion hit";n.length>0&&(n+=","),n+=a+"="+i}t+=n,t+="]"}return t},getRandomString:function(){return Math.random().toString(36).substring(2)},traceVastFromXhr:function(e,r){try{if(e)if(Array.isArray(e)){if(e.length>0){var t=[];for(var o in e)t.push(e[o].responseURL);var i=e[e.length-1];if(i){var s=n(i),u=i.responseURL;a.info(r,"Tag load chain:",t,"\n","Final Tag URL: ",u,"\n","Final Tag: ",s)}}}else{var l=n(e);a.info(r,"Tag URL:",e.responseURL,"\n","Tag:",l)}}catch(c){}}}},function(e,r,t){function n(e,r,t){switch(k){case 0:i(e,r);break;case 1:l(e,r,t);break;default:case 2:p(e,r)}}function a(e){switch(k){case 0:return s(e);case 1:return c(e);default:case 2:return f(e)}}function o(e){switch(k){case 0:u(e);break;case 1:d(e);break;default:case 2:v(e)}}function i(e,r){localStorage&&localStorage.setItem(e,r)}function s(e){if(localStorage)return localStorage.getItem(e)}function u(e){localStorage&&localStorage.removeItem(e)}function l(e,r,t){P.setItem(e,r,t?1/0:new Date(Date.now()+V).toUTCString())}function c(e){return P.getItem(e)}function d(e){P.removeItem(e)}function p(e,r){C&&(C[e]=r)}function f(e){if(C)return C[e]}function v(e){C&&delete C[e]}function g(){try{if(localStorage){var e="apntestls"+Math.random();try{return localStorage.setItem(e,e),localStorage.removeItem(e),!0}catch(r){}}}catch(r){}return!1}function h(){try{if(document&&document.cookie){var e="apntestcookie"+Math.random();try{P.setItem(e,e,1/0);var r=P.hasItem(e)&&P.getItem(e)===e;return P.removeItem(e),r}catch(t){}}}catch(t){}return!1}function m(e,r){var t={};t.timestamp=(new Date).getTime(),t.ad=e;try{n(r,JSON.stringify(t))}catch(a){}}function y(e){var r,t=(new Date).getTime();try{var n=a(e);r=n&&JSON.parse(n),o(e)}catch(i){}if(r&&r.timestamp&&r.timestamp>0){var s=t-r.timestamp;if(s<=V)return r.ad}return null}function b(e){try{o(e)}catch(r){}}function w(e){V=e*O}function T(){var e,r;return r=a(x),e=r?parseInt(r):0,n(x,e+=1,!0),e}function A(e){return"apn_"+e}var k,N=t(4),E="Cache Manager",_=40,O=6e4,S=_*O,V=S,I="___appnexus_video_cachemanager_generic_data___",x="___appnexus_video_cachemanager_ad_token___",C={};k=g()?0:h()?1:2,N.debug("Using Cache Method "+k,E);var P={getItem:function(e){return e?decodeURIComponent(document.cookie.replace(new RegExp("(?:(?:^|.*;)\\s*"+encodeURIComponent(e).replace(/[\-\.\+\*]/g,"\\$&")+"\\s*\\=\\s*([^;]*).*$)|^.*$"),"$1"))||null:null},setItem:function(e,r,t,n,a,o){if(!e||/^(?:expires|max\-age|path|domain|secure)$/i.test(e))return!1;var i="";if(t)switch(t.constructor){case Number:i=t===1/0?"; expires=Fri, 31 Dec 9999 23:59:59 GMT":"; max-age="+t;break;case String:i="; expires="+t;break;case Date:i="; expires="+t.toUTCString()}return document.cookie=encodeURIComponent(e)+"="+encodeURIComponent(r)+i+(a?"; domain="+a:"")+(n?"; path="+n:"")+(o?"; secure":""),!0},removeItem:function(e,r,t){return!!this.hasItem(e)&&(document.cookie=encodeURIComponent(e)+"=; expires=Thu, 01 Jan 1970 00:00:00 GMT"+(t?"; domain="+t:"")+(r?"; path="+r:""),!0)},hasItem:function(e){return!!e&&new RegExp("(?:^|;\\s*)"+encodeURIComponent(e).replace(/[\-\.\+\*]/g,"\\$&")+"\\s*\\=").test(document.cookie)},keys:function(){for(var e=document.cookie.replace(/((?:^|\s*;)[^\=]+)(?=;|$)|^\s*|\s*(?:\=[^;]*)?(?:\1|$)/g,"").split(/\s*(?:\=[^;]*)?;\s*/),r=e.length,t=0;t<r;t++)e[t]=decodeURIComponent(e[t]);return e}};e.exports={setGenericData:function(e,r){if("undefined"!=typeof e&&"undefined"!=typeof r){e=I+e;try{return n(e,r),!0}catch(t){}}return!1},getGenericData:function(e){if("undefined"!=typeof e)return e=I+e,a(e)},deleteGenericData:function(e){"undefined"!=typeof e&&(e=I+e,o(e))},forceStorageMethod:function(e){k=e,N.debug("Forced usage of cache method "+k,E)},addAd:function(e,r){e&&m(e,A(r))},getAd:function(e){return y(A(e))},clearAd:function(e){b(A(e))},setTimeToLive:function(e){w(e)},getNextAdToken:function(){return T()}}},function(e,r,t){var n=(new Date).getTime()+Math.floor(1e4*Math.random()),a="APNMediation_"+n,o=function(e,r,n,a,o,i){function s(e){var r=t(4);r.logDebug(e,"Mediation Manager")}function u(){var e=t(3);e.log("Mediation Manager",arguments)}function l(){if(!Y){Y=!0;var e=null;if(0===S){var r=t(8),n=r.getUnwrappedVastTag(W,K?C.adToken:null,L?q.notify_url:null,L?q.content_source:null);n&&n.length>0&&(e=n)}else if(1===S)e=W,e.name=q.name;else if(2===S){if("video"===q.ad_type){var a=t(8),o=a.getUnwrappedVastTag(W,K?C.adToken:null,L?q.notify_url:null,L?q.content_source:null);q[q.content_source].video.content=o}e=q}e.hasOwnProperty("vastXml")&&delete e.vastXml,V(S,e,P),I(C.adToken,"ad-selection",q.name,null)}}function c(e){for(var r=[],t=0;t<$.length;t++)e.priority>C.ads[$[t]].priority&&r.push($[t]);return $=r,0===$.length}function d(e,r){return e.source.priority-r.source.priority}function p(){if(Z>0&&clearTimeout(Z),L){var e=null,r=0,n=0,a=0;if(R.length>0){var o=t(8),i=[];R.length>1&&R.sort(d);for(var p=0;p<R.length;p++){var v=o.getUnwrappedVastTag(R[p].data,K?C.adToken:null,R[p].source.notify_url,R[p].source.content_source);v&&v.length>0&&(i.push(v),"csm"===R[p].source.content_source?r++:"rtb"===R[p].source.content_source?n++:a++,s("Waterfall: The folloowing <Ad> node added to output: Ad id - "+R[p].data.adId+", type - "+R[p].source.content_source+", priority order - "+(p+1)+", network name - "+R[p].source.name)),R[p].data.hasOwnProperty("vastXml")&&delete R[p].data.vastXml}if(i.length>0){var g=o.getMergedVastTag(i),h=R[0].source;e={content_source:h.content_source,ad_type:h.ad_type,creative_id:h.creative_id,buyer_member_id:h.buyer_member_id,media_type_id:h.media_type_id,media_subtype_id:h.media_subtype_id,renderer_url:h.renderer_url,renderer_id:h.renderer_id,client_initiated_ad_counting:h.client_initiated_ad_counting};var m=h.content_source;e[m]={},e[m][e.ad_type]=h[m][h.ad_type],e[m][e.ad_type].content=g,e[m].timeout_ms=h[m].timeout_ms,u("Waterfall: Object passed to external caller: ",e),s("Waterfall: VAST xml passed to external caller: \n"+g)}}else if($.length>0)return void _();s("Waterfall: Vast XML node count created: # csm nodes: "+r+", # rtb nodes: "+n+(a>0?", # other nodes: "+a:"")),V(S,e,P)}else if(!G)if(W||q.priority<999){if(2===S&&!c(q))return void _();s("Try to send winner"),l()}else{if($.length>0)return void _();s("Send empty response"),V(S,null,P)}f()}function f(){if(!z){z=!0;for(var e=0;e<C.ads.length;e++){var r=C.ads[e];I(C.adToken,"ad-request",r.name,null);var t={};if(r.hasOwnProperty("reason")){t.reason=r.reason;var n=r.hasOwnProperty("wrapper")&&r.wrapper,a=r.hasOwnProperty("endVpaid");n||a?n&&!a?(t.latency_type=2,t.latency=r.endVast-r.startVast):!n&&a?(t.latency_type=3,t.latency=r.endVpaid-r.startVpaid+(r.endVast-r.startVast)):n&&a&&(t.latency_type=4,t.latency=r.endVpaid-r.startVpaid+(r.endVast-r.startVast)):(t.latency_type=1,t.latency=r.endVast-r.startVast),4===r.reason&&(t.latency_type=5,r.hasOwnProperty("endVpaid")?t.latency=r.endVpaid-r.startVast:r.hasOwnProperty("endVast")?t.latency=r.endVast-r.startVast:t.latency=F),t.latency>X&&(t.latency=F),s("interruptProcess: call _trackingCallback with reason = "+t.reason),I(C.adToken,"ad-response",r.name,t)}else G?(t.reason=4,t.latency_type=5,t.latency=NaN):(t.reason=7,t.latency_type=5,t.latency=F),s("interruptProcess: call _trackingCallback with termination reason = "+t.reason),I(C.adToken,"ad-response",r.name,t)}x&&x()}}function v(){for(var e=0;e<C.ads.length;e++){var r=C.ads[e];r.hasOwnProperty("parser")&&r.parser&&!r.hasOwnProperty("reason")&&(r.parser.terminate(),delete r.parser),r.hasOwnProperty("selData")&&delete r.selData}l()}function g(e){return!(!e.hasOwnProperty("durationMsecs")||e.durationMsecs<=0)&&!(!e.hasOwnProperty("mediaFiles")||!Array.isArray(e.mediaFiles)||0===e.mediaFiles.length)}function h(e){var r=M.playerTechnology;r||(r=["html5","flash"]);for(var t=0;t<e.length;t++)if(e[t].apiFramework&&e[t].apiFramework.toLowerCase().indexOf("vpaid")>=0&&e[t].type.toLowerCase()===("html5"===r[0]?"application/javascript":"application/x-shockwave-flash"))return{url:e[t].url,type:"html5"===r[0]?"application/javascript":"application/x-shockwave-flash"};if(r.length>1)for(t=0;t<e.length;t++)if(e[t].apiFramework&&e[t].apiFramework.toLowerCase().indexOf("vpaid")>=0&&e[t].type.toLowerCase()===("html5"===r[1]?"application/javascript":"application/x-shockwave-flash"))return{url:e[t].url,type:"html5"===r[1]?"application/javascript":"application/x-shockwave-flash"};return null}function m(e,r,n){if(s("processValue: source.name = "+r.name),r.endVast=(new Date).getTime(),B)return G?r.reason=4:r.reason=7,void s("processValue: _bDone = true,  source.reason = "+r.reason);if(J--,s("processValue: start process source, succ = "+e),!e)return"terminated"===n?G?r.reason=4:r.reason=7:("vast"===n.substr(0,4)?(n=n.substr(4),"110"===n?r.reason=2:r.reason=5):"Timeout"===n?r.reason=1:r.reason=8,r.errorType="Timeout"===n?2:1,1===r.reason?r.errorCode=408:r.errorCode=n),void(0===J&&(B=!0,s("processValue: all sources processed (parser failed)"),p()));if(!n)return r.endVast=(new Date).getTime(),r.wrapper=!1,r.reason=0,(1===r.priority||r.priority<q.priority)&&(q=r,W=null,1===r.priority&&(G=!0,s("processValue: winner banner 1st priority"),v())),void(0===J&&(B=!0,s("processValue: all sources processed banner"),p()));if(r.wrapper=n.withWrapper,n&&!g(n))return r.reason=3,r.errorType=1,r.errorCode=n,void(0===J&&(B=!0,s("processValue: all sources processed (invalid data)"),p()));if(!B&&C.checkVpaid){var a=h(n.mediaFiles);if(a){var o;if("application/javascript"===a.type)s("processValue: js vpaid support"),J++,r.selData=n,r.startVpaid=(new Date).getTime(),o=j-(new Date).getTime(),Q(r.name,a.url,o,n.adParameters,n.extensions,b);else{s("processValue: flash vpaid support");var i=t(9),u=i.supportsFlash();if(u){var l=document.getElementById("apn_vpaid_swf_loader");if(l){J++,r.selData=n,r.startVpaid=(new Date).getTime(),o=j-(new Date).getTime();try{l.loadCreative(r.name,a.url,o,n.adParameters,n.extensions)}catch(c){s("processValue: flash loader not ready yet, try in 100 msecs"),setTimeout(function(){try{s("processValue: flash 2nd try for "+r.name),l.loadCreative(r.name,a.url,o,n.adParameters,n.extensions)}catch(e){J--,r.reason=1,0===J&&(B=!0,s("processValue: all sources processed (flash loader not ready)"),p())}},100)}}else r.reason=5,0===J&&(B=!0,s("processValue: all sources processed (swf loader container not exist)"),p())}else r.reason=5,0===J&&(B=!0,s("processValue: all sources processed (not support flash)"),p())}return}}r.reason=0,L?R.push({source:r,data:n}):(1===r.priority||r.priority<q.priority)&&(q=r,W=n,1===r.priority&&(G=!0,s("processValue: winner 1st priority"),v())),0===J&&(B=!0,s("processValue: all sources processed"),p())}function y(e){for(var r=0;r<C.ads.length;r++){var t=C.ads[r];if(t.name===e)return t}return null}function b(e){var r=e.name;switch(r){case"ready":s("callerNotification: loader ready"),D=!0,O();break;case"debug":s(e.message);break;case"error":s(e.message);var t=y(e.id);if(t){switch(J--,t.endVpaid=(new Date).getTime(),e.code){case 900:t.reason=7;break;case 401:t.reason=8;break;case 901:t.reason=8}t.errorType=2,1===t.reason?t.errorCode=408:t.errorCode=e.code,0!==J||B||(s("callerNotification: all sources processed (vpaid error)"),B=!0,p())}break;case"success":t=y(e.id),t&&(J--,t.endVpaid=(new Date).getTime(),G?t.reason=4:(t.reason=0,L?R.push({source:t,data:t.selData}):(1===t.priority||t.priority<q.priority)&&(q=t,W=t.selData,1===t.priority&&(G=!0,s("processValue: winner vpaid 1st priority"),v()))),0!==J||B||(s("callerNotification: all sources processed (vpaid)"),B=!0,p()))}return null}function w(e){var r="";return e.hasOwnProperty("ad_type")?r=e.ad_type:e.hasOwnProperty("format")&&(Array.isArray(e.format)?e.format.length>0&&(r=e.format[0].toString()):r=e.format.toString()),r.toLowerCase()}function T(e){return"vast"===e||"video"===e||"banner"===e}function A(e,r){return"video"===r&&e[e.content_source]&&e[e.content_source].hasOwnProperty("content")&&"string"==typeof e[e.content_source].content?e[e.content_source].content:e[e.content_source]&&e[e.content_source][e.ad_type]&&e[e.content_source][e.ad_type].hasOwnProperty("content")?e[e.content_source][e.ad_type].content:e[e.content_source]&&e[e.content_source].hasOwnProperty("content")&&"string"==typeof e[e.content_source].content?e[e.content_source].content:"vast"===r&&e.hasOwnProperty("content")&&"string"==typeof e.content?e.content:null}function k(e,r,t){var n,a;if(2===t){if("csm"===e.content_source&&e.csm.hasOwnProperty("handler")&&Array.isArray(e.csm.handler)&&e.csm.handler.length>0)for(n=0;n<e.csm.handler.length;n++)if(a=e.csm.handler[n],a.hasOwnProperty("url")&&"string"==typeof a.url&&a.url.length>0)return a.url;if("ssm"===e.content_source&&e.ssm.hasOwnProperty("ssm_url")&&e.ssm.ssm_url.length>0)return e.ssm.ssm_url;if("rtb"===e.content_source&&e.rtb.hasOwnProperty("handler")&&Array.isArray(e.rtb.handler)&&e.rtb.handler.length>0)for(n=0;n<e.rtb.handler.length;n++)if(a=e.rtb.handler[n],a.hasOwnProperty("url")&&"string"==typeof a.url&&a.url.length>0)return a.url}else{if("ssm"===e.content_source&&"video"===r&&e.ssm.hasOwnProperty("url")&&"string"==typeof e.ssm.url&&e.ssm.url.length>0)return e.ssm.url;if("video"===r&&e[e.content_source]&&e[e.content_source].hasOwnProperty("handler")&&Array.isArray(e[e.content_source].handler)&&e[e.content_source].handler.length>0)for(n=0;n<e[e.content_source].handler.length;n++)if(a=e[e.content_source].handler[n],a.hasOwnProperty("url")&&"string"==typeof a.url&&a.url.length>0)return a.url;if(("ssm"===e.type||"rtb"===e.type)&&("url"===r||"vast"===r)&&e.hasOwnProperty("url")&&"string"==typeof e.url&&e.url.length>0)return e.url;if("vast"===r&&e.hasOwnProperty("handler")&&Array.isArray(e.handler)&&e.handler.length>0)for(n=0;n<e.handler.length;n++)if(a=e.handler[n],a.hasOwnProperty("url")&&"string"==typeof a.url&&a.url.length>0)return a.url}return null}function N(e){if(!G){var r=j-(new Date).getTime();if(r>0){var n=w(e);if(!T(n))return J--,e.reason=5,e.errorType=0,void(0===J&&(B=!0,p()));var a=A(e,n);if(a&&a.length>0){if(e.startVast=(new Date).getTime(),2===S&&"banner"===e.ad_type)return void m(!0,e,null);var o=t(8),i=o.parse(a,m,e,r,e.video_trackers?e.video_trackers:e[e.content_source]?e[e.content_source].trackers:null,e.imp_tracking_url,M);return void(e.parser=i)}var s=k(e,n,S);if(!s||0===s.length)return J--,e.reason=5,e.errorType=0,void(0===J&&(B=!0,p()));e.startVast=(new Date).getTime();var u=t(2);u.load(s,function(n,a){if(n)J--,e.reason="Timeout"===n?1:8,e.errorType=2,1===e.reason?e.errorCode=408:e.errorCode=n,0===J&&(B=!0,p());else if(2===S&&"banner"===e.ad_type)m(!0,e,null);else{var o=t(8),i=o.parse(a,m,e,r,e.video_trackers?e.video_trackers:e[e.content_source]?e[e.content_source].trackers:null,e.imp_tracking_url,M);e.parser=i}},r)}}}function E(e){s("processSequnsialWinner: source.name = "+e.name),e.endVast=(new Date).getTime(),e.wrapper=!1,e.reason=0,q=e,W=null,B=!0,Z>0&&clearTimeout(Z),v(),f()}function _(){if(0===$.length)return B=!0,void p();var e=C.ads[$[0]];$.splice(0,1);var r=w(e);if(!T(r))return e.reason=5,e.errorType=0,void _();var n=A(e,r);if(n&&n.length>0)return e.startVast=(new Date).getTime(),$.length=[],void E(e);var a=k(e,r,S);if(!a||0===a.length)return e.reason=5,e.errorType=0,void _();e.startVast=(new Date).getTime();var o=t(2);o.load(a,function(r,t){r?(e.reason=8,e.errorCode=r,_()):(e[e.content_source].banner.content=t,$.length=[],E(e))},null)}function O(){if(B)return void x();for(var e=C.ads,r=1,t=0;t<e.length;t++)2===S&&"ssm"!==e[t].content_source&&(e[t].client_initiated_ad_counting?H.push(t):$.push(t)),e[t].hasOwnProperty("content_source")||(e[t].content_source=e[t].mediation_type,e[t].content_source||(e[t].content_source=e[t].type)),e[t].hasOwnProperty("must_serve")&&"boolean"==typeof e[t].must_serve&&e[t].must_serve&&(e[t].priority=r++);for(t=0;t<e.length;t++)e[t].hasOwnProperty("must_serve")&&"boolean"==typeof e[t].must_serve&&e[t].must_serve===!0||(e[t].priority=r++);if(2===S)if($.length>1&&$.sort(function(r,t){return e[r].priority-e[t].priority}),H.length>0)J=H.length,H.sort(function(r,t){return e[r].priority-e[t].priority}),H.forEach(function(e){N(C.ads[e])});else{if(!($.length>0))return void p();_()}else J=C.ads.length,C.ads.forEach(N)}var S=n,V=a,I=o,x=null,C=e,P=r,M=i,L=C&&C.waterfall,R=[],D=!0,U=C&&C.timeout_ms?C.timeout_ms:6e4;6e4===U&&(U=C&&C.publisher_settings&&C.publisher_settings.timeout_ms?C.publisher_settings.timeout_ms:6e4);var F=U;U-=C&&C.impbusResponseTime?C.impbusResponseTime:0;var X=U,j=(new Date).getTime()+U,J=0,q={priority:999},W=null,B=!1,G=!1,H=[],$=[],Y=!1,z=!1,K=!!C.returnAdToken&&C.returnAdToken,Q=t(7);s("Remaining timeout = "+X);var Z=0;X>0?Z=setTimeout(function(){B=!0;for(var e=0;e<C.ads.length;e++){var r=C.ads[e];r.hasOwnProperty("parser")&&r.parser&&!r.hasOwnProperty("reason")&&(r.parser.terminate(),delete r.parser),r.hasOwnProperty("selData")&&delete r.selData}p()},X):(B=!0,p()),s("Version 0.1.14"),this.callerNotification=function(e){return b(e)},this.processMediation=function(e){
if(x=e,B)return void x();var r=C.ads;return r&&0!==r.length?(s("processMediation: _readyForVpaid = "+D),void(D&&O())):void p()},this.setNotReady=function(){D=!1}};e.exports={processMediationSources:function(e,r,n,i,s,u){var l=t(9),c=!1,d=l.supportsFlash();if(d&&e.checkVpaid){var p=document.getElementById("vpaidLoaderContainer");if(!p){p=document.createElement("div"),p.id="vpaidLoaderContainer";var f="http://acdn.adnxs.com/video/mediation/SwfVpaidLoader.swf",v=document.createElement("object");v.type="application/x-shockwave-flash",v.data=f,v.width="1px",v.height="1px",v.id="apn_vpaid_swf_loader",v.style.display="block",v.style.top="0",v.style.left="0",v.style.width="1px",v.style.height="1px";var g=document.createElement("param");g.name="flashvars",g.value="external="+a,v.appendChild(g);var h=document.createElement("param");h.name="allowScriptAccess",h.value="always",v.appendChild(h);var m=document.createElement("param");m.name="allowNetworking",m.value="all",v.appendChild(m);var y=document.createElement("param");y.name="allowNetworking",y.value="all",v.appendChild(y);var b=document.createElement("param");b.name="wmode",b.value="opaque",v.appendChild(b),p.appendChild(v),document.body.appendChild(p),c=!0}}var w=new o(e,r,n,i,s,u);window[a]=w,c&&w.setNotReady(),w.processMediation(function(){w=null})}}},function(e,r){var t=function(e,r,t,n,a,o){function i(e,r,t){y(e?{name:"success",id:v}:{name:"error",message:r,id:v,code:t}),document.body.removeChild(p)}function s(e){y({name:"debug",message:e})}function u(){return!!(f.handshakeVersion&&"function"==typeof f.handshakeVersion&&f.initAd&&"function"==typeof f.initAd&&f.subscribe&&"function"==typeof f.subscribe&&f.unsubscribe&&"function"==typeof f.unsubscribe)}function l(){for(var e in T)f.subscribe(T[e],e,this)}function c(){for(var e in T)f.unsubscribe(T[e],e)}function d(){if(!b){if(!u())return clearTimeout(w),s("JS VPAID >>>> JS code does not support VPAID interface"),void i(!1,"JS code does not support VPAID interface",901);if(l(),!b){var e=f.handshakeVersion("3.0.0");s("JS VPAID >>>> VPAID version = "+e);var r=document.createElement("div");p.contentWindow.document.body.appendChild(r);var t=document.createElement("video");r.appendChild(t),b||f.initAd(1,1,"normal",400,{AdParameters:h?h:JSON.stringify(m)},{flashVars:"",slot:r,videoSlot:t})}}}var p,f,v=e,g=r,h=n,m=a,y=o,b=!1,w=setTimeout(function(){clearTimeout(w),b=!0,s("JS VPAID >>>> Time-out"),i(!1,"Time-out",900)},t);this.onAdLoaded=function(){c(),b||(clearTimeout(w),s("JS VPAID >>>> AdLoaded called"),i(!0))},this.onAdError=function(e){c(),b||(clearTimeout(w),s("JS VPAID >>>> AdError message: "+e),i(!1,"VPAID init error",901))},this.onAdLog=function(e){s("JS VPAID >>>> AdLog message: "+e)};var T={AdLoaded:this.onAdLoaded,AdError:this.onAdError,AdLog:this.onAdLog};p=document.createElement("iframe"),p.onload=function(){var e=p.contentWindow.document.createElement("script");e.src=g,e.onload=function(){var e=p.contentWindow.getVPAIDAd;e&&"function"==typeof e?(f=e(),d()):(clearTimeout(w),s("JS VPAID >>>> JS code is not VPAID"),i(!1,"JS code is not VPAID",401))},p.contentWindow.document.body.appendChild(e)},p.id="jsVpaidLoader"+(new Date).getTime(),document.body.appendChild(p)};e.exports=t},function(e,r,t){var n=function(){this.getSubNodes=function(e,r){var t=e.getElementsByTagName(r);return t.length>0?t:null},this.getSubNode=function(e,r,t){t||(t=0);var n=e.getElementsByTagName(r);return n.length>t?n[t]:null},this.getNodeValue=function(e){if(0===e.childNodes.length)return"";var r=e.childNodes[0].nodeValue;return r.trim()},this.getNodeValues=function(e){if(0===e.childNodes.length)return"";for(var r="",t=0;t<e.childNodes.length;t++){var n=e.childNodes[t].nodeValue;r+=n}return r.trim()},this.getNodeAttributeValue=function(e,r){var t=e.getAttribute(r);return null===t&&(t=""),t},this.getNodeAttributeNumberValue=function(e,r,t){t||(t=0);var n=t,a=this.getNodeAttributeValue(e,r);return a.length>0&&(n=a.indexOf(".")>=0?parseFloat(a):parseInt(a)),n},this.getNodeAttributeBooleanValue=function(e,r,t){t||(t=!1);var n=t,a=this.getNodeAttributeValue(e,r);if(a.length>0){var o=a.toLowerCase().charAt(0);n="t"===o}return n},this.getSubNodeValue=function(e,r,t){t="undefined"==typeof t?"":t;var n=this.getSubNode(e,r);return null!==n?this.getNodeValue(n):t},this.getSubNodeWholeValue=function(e,r,t){t="undefined"==typeof t?"":t;var n=this.getSubNode(e,r);return null!==n?this.getNodeValues(n):t},this.getSubNodeBooleanValue=function(e,r,t){t="undefined"==typeof t?"false":t;var n=this.getSubNodeValue(e,r);return n.length>0&&"t"===n.toLowerCase().charAt(0)||!(n.length>0&&"f"===n.toLowerCase().charAt(0))&&t}},a=function(e,r,a){function o(e){var r=t(4);r.logDebug(e,"VAST Parser")}function i(e){var r="unknown";return e&&(r=de.getNodeAttributeValue(e,"version")),r}function s(e,r){if(e&&e.length>0)for(var t=0;t<e.length;t++)e[t]=e[t].replace("[ERRORCODE]",r)}function u(e,r){for(var t=e,n="AD DETECTED="+("SUCCESS"===r.substr(0,7)?"SUCCESS":"NONE")+" :: Reason="+r+", playerTechnology="+(G.hasOwnProperty("playerTechnology")?JSON.stringify(G.playerTechnology):"unknown")+", platform="+ye.getPlatformType()+", Ad tree path=",a="";t!==-1;){var i=ge[t].children[0];if(i){var s=de.getNodeAttributeValue(i,"id");a.length>0&&(a=" -> "+a),a=s+a}t=ge[t].parentIdx}o(n+a)}function l(e){var r=de.getSubNode(e,"VASTAdTagURI");if(!r)return u(he,"INVALID WRAPPER NODE"),void(0===ge.length?_("300","invalid wrapper node"):O());var n=de.getNodeValues(r);if(!n||0===n.length)return u(he,"EMPTY VASTAdTagURI"),void(0===ge.length?_("300","Invalid VASTAdTagURI node value"):O());if(me)return u(he,"terminated"),void B(!1,$,"terminated",null);fe=!0;var a=t(2);a.load(n,function(e,r){return me?(u(he,"terminated"),void B(!1,$,"terminated",null)):void(e||0===r.length?(u(he,"VASTAdTagURI TIMED OUT: "+n),0===ge.length?_("301","Timeout of VAST URI provided in wrapper element"):O()):(Te=!1,I(r)))},Y)}function c(e,r){for(var t=0;t<e.length;t++)if(e[t]===r)return!0;return!1}function d(e,r){if(e){var t=de.getSubNodes(e,"Error");if(t)for(var n=0;n<t.length;n++){var a=t[n],o=de.getNodeValues(a);o&&!c(r,o)&&r.push(o)}}}function p(e,r){if(e){var t=de.getSubNodes(e,"Impression");if(t)for(var n=0;n<t.length;n++){var a=t[n],o=de.getNodeValues(a);o&&!c(r,o)&&r.push(o)}}}function f(e,r){if(e){var t=de.getSubNode(e,"Linear",0);if(t){var n=de.getSubNode(t,"TrackingEvents");if(n){var a=de.getSubNodes(n,"Tracking");if(a)for(var o=0;o<a.length;o++){n=a[o];var i=de.getNodeValues(n);if(i){var s=de.getNodeAttributeValue(n,"event");r.hasOwnProperty(s)?c(r[s],i)||r[s].push(i):(r[s]=[],r[s].push(i))}}}}}}function v(e,r){if(e){var t=de.getSubNode(e,"Extensions");t&&t.innerHTML&&t.innerHTML.length>0&&(ge[r].state.sExtensions=ge[r].state.sExtensions+t.innerHTML.toString())}}function g(e,r,t){if(e){var n=de.getSubNode(e,"Linear",0);if(n){var a=null,o=de.getSubNode(n,"VideoClicks");if(o){var i=de.getSubNode(o,"ClickThrough");i&&(a=de.getNodeValues(i),a&&!c(r,a)&&r.push(a));var s=de.getSubNodes(o,"ClickTracking");if(s)for(var u=0;u<s.length;u++)i=s[u],a=de.getNodeValues(i),a&&!c(t,a)&&t.push(a)}}}}function h(e,r){var t=e.indexOf("%");if(t>0)return r&&r>0?Number(e.substring(0,t)):0;t=e.indexOf(".");var n=t>0?Number(e.substring(t+1)):0;t>0&&(e=e.substring(0,t));var a=e.split(":");return 3===a.length?1e3*(3600*Number(a[0])+60*Number(a[1])+Number(a[2]))+n:0}function m(e,r){return ye.canPlay(e,r)}function y(e){return"video/x-flv"===e||"video/x-f4v"===e||"video/f4v"===e||"application/x-shockwave-flash"===e}function b(e){return"video/webm"===e||"video/ogg"===e||"application/javascript"===e||"application/x-javascript"===e}function w(e){return"application/x-shockwave-flash"===e||"application/javascript"===e||"application/x-javascript"===e}function T(e){if(G.playerTechnology&&Array.isArray(G.playerTechnology)&&G.playerTechnology.length>0){for(var r=!1,t=0;t<G.playerTechnology.length;t++){var n=G.playerTechnology[t].toLowerCase();if(!y(e.toLowerCase())&&!b(e.toLowerCase())){r=!0;break}if("flash"===n&&!b(e.toLowerCase())){r=!0;break}if("html5"===n&&!y(e.toLowerCase())){r=!0;break}}if(!r)return!1}return!(G.hasOwnProperty("supportVpaid")&&!G.supportVpaid&&w(e.toLowerCase()))}function A(e,r,t,n){var a=null;if(e){if(a={},a.type=de.getNodeAttributeValue(e,"type"),n.indexOf(a.type)===-1&&n.push(a.type),!a.type||0===a.type.length)return null;var o=de.getNodeAttributeValue(e,"codec");if(o&&o.length>0&&(a.codec=o),!m(a.type,o))return null;if(G&&!T(a.type))return null;a.url=r,a.variation="Media#"+t,a.delivery=de.getNodeAttributeValue(e,"delivery");var i=de.getNodeAttributeNumberValue(e,"bitrate",-1);i!==-1&&(a.bitrate=i),a.width=de.getNodeAttributeNumberValue(e,"width"),a.height=de.getNodeAttributeNumberValue(e,"height");var s=de.getNodeAttributeValue(e,"scalable");s.length>0&&(a.scalable=de.getNodeAttributeBooleanValue(e,"scalable",!0)),s=de.getNodeAttributeValue(e,"maintainAspectRatio"),s.length>0&&(a.maintainAspectRatio=de.getNodeAttributeBooleanValue(e,"maintainAspectRatio",!0));var u=de.getNodeAttributeValue(e,"apiFramework");u&&u.length>0&&(a.apiFramework=u.toUpperCase())}return a}function k(e){ae=0,oe=0,ne="",z=[];var r="",t=[];if(e){var n=de.getSubNode(e,"Linear",0);if(n){var a=de.getSubNode(n,"Duration");if(a){var o=de.getNodeValue(a);ae=h(o,-1)}var i=de.getNodeAttributeValue(n,"skipoffset");if(i&&i.length>0&&(oe=h(i,ae)),ne=de.getSubNodeWholeValue(n,"AdParameters",""),a=de.getSubNode(n,"MediaFiles")){var s=de.getSubNodes(a,"MediaFile");if(s){for(var u=0;u<s.length;u++){a=s[u];var l=de.getNodeValues(a);if(l.length>0){var c=A(a,l,u,t);c&&z.push(c)}}0===z.length&&(r="INCOMPATIBLE MEDIA TYPE, Available = "+JSON.stringify(t))}else r="MISSING MEDIA FILES"}else r="MISSING MEDIA FILES"}else r="INVALID VAST STRUCTURE"}return r}function N(e){var r=e.indexOf("<"),t=e.substr(r===-1?0:r);return r=t.lastIndexOf(">"),r!==-1&&(t=t.substr(0,r+1)),t.trim()}function E(e){return"2.0"===e||"3.0"===e}function _(e,r){s(re,e),o("Error "+e+" - "+r),B(!1,$,"vast"+e,re)}function O(){if(he>=0){if(ge[he].children[0]=null,ge[he].children.splice(0,1),0===ge[he].children.length){var e=ge[he].parentIdx;return ge.splice(he,1),he=e,he===-1?void(be&&we.length>0?(o("Waterfall: Vast XML node count detected: # csm nodes: "+Ne+", # rtb nodes: "+Ee),B(!0,$,we,null)):_("900","no Ad available")):void O()}ge[he].state=S(),q(ge[he].children[0])}}function S(){var e={arrTrackings:{},arrImpressions:[],arrClickUrls:[],arrClickTrackings:[],arrErrorUrls:[],sExtensions:""};return e}function V(e){var r=de.getNodeAttributeValue(e,"id");if(r.length>0){var t=de.getNodeAttributeValue(e,"notifyurl");t&&t.length>0&&(Ae[r]=t)}}function I(e){pe=(new Date).getTime(),H=e;var r=N(e);if(0===r.length)return u(he,"EMPTY VAST"),void(0===ge.length?_("110","no bid response for mediation"):O());var t=null;if("undefined"!=typeof window.DOMParser){if(t=(new DOMParser).parseFromString(r,"text/xml"),"parsererror"===t.documentElement.nodeName){try{o("Error reason = "+t.documentElement.childNodes[0].nodeValue)}catch(n){}return u(he,"INVALID VAST STRUCTURE"),void(0===ge.length?_("100","VAST XML parsing error"):O())}}else{if("undefined"==typeof window.ActiveXObject)return o("Failed to parse vast xml by window.ActiveXObject(Microsoft.XMLDOM)"),u(he,"INVALID VAST STRUCTURE"),void(0===ge.length?_("100","Failed to get vast xml"):O());try{if(t=new window.ActiveXObject("Microsoft.XMLDOM"),t.loadXML(r),0!==t.parseError.errorCode)return o(t.parseError.errorCode+", Error reason = "+t.parseError.reason),u(he,"INVALID VAST STRUCTURE"),void(0===ge.length?_("100",t.parseError.errorCode+", Error reason = "+t.parseError.reason):O())}catch(a){return o("Failed to parse vast xml by window.ActiveXObject(Microsoft.XMLDOM)"),u(he,"INVALID VAST STRUCTURE"),void(0===ge.length?_("100","Failed to parse vast xml by window.ActiveXObject(Microsoft.XMLDOM)"):O())}}if(!t)return u(he,"INVALID VAST STRUCTURE"),void(0===ge.length?_("102","VAST XML parsing error"):O());var s=de.getSubNode(t,"VAST");if(!s)return u(he,"EMPTY VAST"),void(0===ge.length?_("110","no bid response for mediation"):O());var l=i(s);if(E(l)){Te&&(be=de.getNodeAttributeBooleanValue(s,"apn_waterfall"),be&&(G.waterfall=!0));var c=de.getSubNodes(s,"Ad");if(!c||0===c.length)return u(he,"NO AD NODE"),void(0===ge.length?_("900","no Ad available"):O());for(var d=[],p=0;p<c.length;p++)d.push(c[p]),be&&Te&&V(c[p]);var f={parentIdx:he,currentIdx:0,children:d,state:S()};ge.push(f),f.currentIdx=ge.length-1,he=f.currentIdx,q(ge[he].children[0],l)}else u(he,"INVALID VAST VERSION: "+l),0===ge.length?_("102","VAST version not supported"):O()}function x(e){for(var r in ge[e].state.arrTrackings)for(var t=0;t<ge[e].state.arrTrackings[r].length;t++)ie.hasOwnProperty(r)?c(ie[r],ge[e].state.arrTrackings[r][t])||ie[r].push(ge[e].state.arrTrackings[r][t]):(ie[r]=[],ie[r].push(ge[e].state.arrTrackings[r][t]));return ie}function C(e){for(var r=e;r>=0;)x(r),r=ge[r].parentIdx;return ie}function P(e){for(var r=0;r<ge[e].state.arrImpressions.length;r++)c(se,ge[e].state.arrImpressions[r])||se.push(ge[e].state.arrImpressions[r]);return se}function M(e){for(var r=e;r>=0;)P(r),r=ge[r].parentIdx;return se}function L(e){for(var r=0;r<ge[e].state.arrClickUrls.length;r++)c(ue,ge[e].state.arrClickUrls[r])||ue.push(ge[e].state.arrClickUrls[r]);return ue}function R(e){for(var r=e;r>=0;)L(r),r=ge[r].parentIdx;return ue}function D(e){for(var r=0;r<ge[e].state.arrClickTrackings.length;r++)c(le,ge[e].state.arrClickTrackings[r])||le.push(ge[e].state.arrClickTrackings[r]);return le}function U(e){for(var r=e;r>=0;)D(r),r=ge[r].parentIdx;return le}function F(e){for(var r=0;r<ge[e].state.arrErrorUrls.length;r++)c(ce,ge[e].state.arrErrorUrls[r])||ce.push(ge[e].state.arrErrorUrls[r]);return ce}function X(e){for(var r=e;r>=0;)F(r),r=ge[r].parentIdx;return ce}function j(e){return ge[e].state.sExtensions.length>0&&(te+=ge[e].state.sExtensions),te}function J(e){for(var r=e;r>=0;)j(r),r=ge[r].parentIdx;return te}function q(e,r){var t=de.getSubNode(e,"Wrapper"),n=null!==t;if(n||(t=de.getSubNode(e,"InLine")),!t)return u(he,"MISSING WRAPPER / INLINE NODE"),void O();r>ve&&(ve=r);var a=de.getNodeAttributeValue(e,"id");if(Ae.hasOwnProperty(a)&&(ke=Ae[a]),d(t,ge[he].state.arrErrorUrls),p(t,ge[he].state.arrImpressions),f(t,ge[he].state.arrTrackings),g(t,ge[he].state.arrClickUrls,ge[he].state.arrClickTrackings),v(t,he),n)l(t);else{var o=k(t);if(0===z.length||o.length>0)return u(he,o),void O();ie=JSON.parse(JSON.stringify(K)),se=Q.slice(0),ue=Z.slice(0),le=ee.slice(0),ce=re.slice(0),te="";var i=JSON.stringify(C(ge[he].parentIdx)),s=JSON.stringify(M(ge[he].parentIdx)),c=JSON.stringify(R(ge[he].parentIdx)),h=JSON.stringify(U(ge[he].parentIdx)),m=JSON.stringify(X(ge[he].parentIdx)),y=J(ge[he].parentIdx);te="";var b={vastVersion:ve,withWrapper:fe,mediaFiles:z,trackingUrls:x(he),impressionUrls:P(he),clickUrls:L(he),clickTrackingUrls:D(he),errorUrls:F(he),durationMsecs:ae,skipOffsetMsecs:oe,extensions:j(he),adParameters:ne,vastXml:H,extTrackingUrls:i,extImpressionUrls:s,extClickUrls:c,extClickTrackingUrls:h,extErrorUrls:m,extExtensions:y,adId:a};be&&ke.length>0&&(b.notifyurl=ke);var w=!1;if(be){var T=de.getNodeAttributeValue(e,"rtb");T&&"true"===T&&(w=!0,b.rtb=!0)}if(me)return u(he,"terminated"),void B(!1,$,"terminated",null);for(var A=[],N=0;N<z.length;N++)A.indexOf(z[N].type)===-1&&A.push(z[N].type);u(he,"SUCCESS, Available="+JSON.stringify(A)),be?(we.push(b),w?Ee++:Ne++,O()):B(!0,$,b,null)}}function W(e,r){var t,n,a,o;if(r&&Q.push(r.trim()),e)if(Array.isArray(e)&&1===e.length){var i=e[0];if(i.impression_urls)for(n=0;n<i.impression_urls.length;n++)t=i.impression_urls[n].trim(),Q.push(t);if(i.error_urls)for(n=0;n<i.error_urls.length;n++)t=i.error_urls[n].trim(),re.push(t);if(i.video_click_urls)for(n=0;n<i.video_click_urls.length;n++)t=i.video_click_urls[n].trim(),ee.push(t);for(o in i.video_events)for(a=i.video_events[o],n=0;n<a.length;n++)t=a[n].trim(),K.hasOwnProperty(o)?c(K[o],t)||K[o].push(t):K[o]=[t]}else for(o in e)if("service"!==o)if(Array.isArray(e[o]))for(a=e[o],n=0;n<a.length;n++)t=a[n].trim(),"click"===o?ee.push(t):"error"===o?re.push(t):"impression"===o?Q.push(t):K.hasOwnProperty(o)?c(K[o],t)||K[o].push(t):K[o]=[t];else t=e[o].trim(),"click"===o?ee.push(t):"error"===o?re.push(t):"impression"===o?Q.push(t):K.hasOwnProperty(o)?c(K[o],t)||K[o].push(t):K[o]=[t]}var B=null,G=a,H=null,$=e,Y=r&&r>0?r:1e3,z=[],K={},Q=[],Z=[],ee=[],re=[],te="",ne="",ae=0,oe=0,ie={},se=[],ue=[],le=[],ce=[],de=new n,pe=null,fe=!1,ve="",ge=[],he=-1,me=!1,ye=t(9),be=!1,we=[],Te=!1,Ae={},ke="",Ne=0,Ee=0;o("Version 1.1.5"),this.parse=function(e,r,t,n){B=n,W(r,t),Te=!0,I(e)},this.terminate=function(){me=!0}},o=function(e,r,a,o){function i(e){var r=t(4);r.logDebug(e,"VAST Parser")}function s(e){var r=e.indexOf("<"),t=e.substr(r===-1?0:r);return r=t.lastIndexOf(">"),r!==-1&&(t=t.substr(0,r+1)),t}function u(e){var r=s(e),t=null;if("undefined"!=typeof window.DOMParser){if(t=(new DOMParser).parseFromString(r,"text/xml"),"parsererror"===t.documentElement.nodeName){try{i("Error reason = "+t.documentElement.childNodes[0].nodeValue)}catch(n){}return null}}else{if("undefined"==typeof window.ActiveXObject)return i("Failed to get vast xml parser"),null;try{if(t=new window.ActiveXObject("Microsoft.XMLDOM"),t.loadXML(r),0!==t.parseError.errorCode)return i("Error code = "+t.parseError.errorCode+", Error reason = "+t.parseError.reason),null}catch(a){return i("Failed to parse vast xml by window.ActiveXObject(Microsoft.XMLDOM)"),null}}return t}function l(e){if(b){var r=y.getSubNode(b,"VAST");if(r){var t=b.createAttribute("version");t.value=e,r.setAttributeNode(t)}}}function c(){if(b){var e=y.getSubNode(b,"VAST");if(e){var r=y.getSubNodes(e,"Ad");if(r&&r.length>0)for(var t=0;t<r.length;t++){if(h){var n=b.createAttribute("notifyurl");n.value=h,r[t].setAttributeNode(n)}if(m&&"rtb"===m){var a=b.createAttribute("rtb");a.value="true",r[t].setAttributeNode(a)}}}}}function d(e,r){var t=b.createCDATASection(r);e.appendChild(t)}function p(){if(g){var e=y.getSubNode(b,"VAST"),r=b.createAttribute("adtoken");r.value=g,e.setAttributeNode(r)}var t=y.getSubNode(b,"InLine");if(!t)return null;var n;if(v.extImpressionUrls&&"string"==typeof v.extImpressionUrls){var a=JSON.parse(v.extImpressionUrls);if(Array.isArray(a)&&a.length>0)for(n=0;n<a.length;n++){var o=b.createElement("Impression");d(o,a[n]),t.appendChild(o)}delete v.extImpressionUrls}if(v.extErrorUrls&&"string"==typeof v.extErrorUrls){var i=JSON.parse(v.extErrorUrls);if(Array.isArray(i)&&i.length>0)for(n=0;n<i.length;n++){var s=b.createElement("Error");d(s,i[n]),t.appendChild(s)}delete v.extErrorUrls}if(v.extExtensions&&"string"==typeof v.extExtensions){var u=v.extExtensions;if(u.length>0){var l=y.getSubNode(t,"Extensions");l?l.innerHTML=l.innerHTML.toString()+u:(l=b.createElement("Extensions"),t.appendChild(l),l.innerHTML=u)}delete v.extExtensions}var c=y.getSubNode(t,"Creatives");c||(c=b.createElement("Creatives"),t.appendChild(c));var p=y.getSubNode(c,"Linear");if(!p){var f=b.createElement("Creative");c.appendChild(f),p=b.createElement("Linear"),f.appendChild(p)}return p}function f(e){var r;if(v.extTrackingUrls&&"string"==typeof v.extTrackingUrls&&v.extTrackingUrls.length>5){var t=JSON.parse(v.extTrackingUrls),n=y.getSubNode(e,"TrackingEvents");n||(n=b.createElement("TrackingEvents"),e.appendChild(n));for(var a in t){var o=t[a];for(r=0;r<o.length;r++){var i=b.createElement("Tracking"),s=b.createAttribute("event");s.value=a,i.setAttributeNode(s),d(i,o[r]),n.appendChild(i)}}delete v.extTrackingUrls}var u;if(v.extClickUrls&&"string"==typeof v.extClickUrls){var l=JSON.parse(v.extClickUrls);if(Array.isArray(l)&&l.length>0&&(u=y.getSubNode(e,"VideoClicks"),u||(u=b.createElement("TrackingEvents"),e.appendChild(u)),!y.getSubNode(u,"ClickThrough"))){var c=b.createElement("ClickThrough");d(c,l[0]),u.appendChild(c)}delete v.extClickUrls}if(v.extClickTrackingUrls&&"string"==typeof v.extClickTrackingUrls){var p=JSON.parse(v.extClickTrackingUrls);if(Array.isArray(p)&&p.length>0)for(u=y.getSubNode(e,"VideoClicks"),u||(u=b.createElement("VideoClicks"),e.appendChild(u)),r=0;r<p.length;r++){var f=b.createElement("ClickTracking");d(f,p[r]),u.appendChild(f)}delete v.extClickTrackingUrls}}var v=e,g=r,h=a,m=o,y=new n,b=u(e.vastXml);l(e.vastVersion),c(),this.addTrackers=function(){if(!b)return"";var e=p();if(!e)return"";f(e);var r=(new XMLSerializer).serializeToString(b);return r}},i=function(e){function r(e){var r=t(4);r.logDebug(e,"VAST Parser")}function a(e){var r=e.indexOf("<"),t=e.substr(r===-1?0:r);return r=t.lastIndexOf(">"),r!==-1&&(t=t.substr(0,r+1)),t}function o(e){var t=a(e),n=null;if("undefined"!=typeof window.DOMParser){if(n=(new DOMParser).parseFromString(t,"text/xml"),"parsererror"===n.documentElement.nodeName){try{r("Error reason = "+n.documentElement.childNodes[0].nodeValue)}catch(o){}return null}}else{if("undefined"==typeof window.ActiveXObject)return r("Failed to get vast xml parser"),null;try{if(n=new window.ActiveXObject("Microsoft.XMLDOM"),n.loadXML(t),0!==n.parseError.errorCode)return r("Error code = "+n.parseError.errorCode+", Error reason = "+n.parseError.reason),null}catch(i){return r("Failed to parse vast xml by window.ActiveXObject(Microsoft.XMLDOM)"),null}}return n}var i=e,s=new n,u=o(i[0]);if(u){var l=s.getSubNode(u,"VAST"),c=u.createAttribute("apn_waterfall");c.value=!0,l.setAttributeNode(c);for(var d=1;d<i.length;d++){var p=o(i[d]),f=s.getSubNode(p,"VAST"),v=s.getSubNodes(f,"Ad");if(v&&v.length>0)for(var g=0;g<v.length;g++)l.appendChild(v[g])}this.getVastXml=function(){if(!u)return"";var e=(new XMLSerializer).serializeToString(u);return e}}};e.exports={parse:function(e,r,t,n,o,i,s){var u=new a(t,n,s);return u.parse(e,o,i,function(e,t,n,a){r&&r(e,t,n,a),u=null}),u},getUnwrappedVastTag:function(e,r,t,n){if(!e||!e.vastXml)return null;var a=new o(e,r,t,n),i=a.addTrackers();return a=null,i},getMergedVastTag:function(e){if(!e||0===e.length)return null;var r=new i(e),t=r.getVastXml();return r=null,t}}},function(e,r){function t(){return!!/Android|webOS|iPhone|iPad|BlackBerry|IEMobile|Windows Phone|Kindle|Silk|Opera Mini/i.test(navigator.userAgent)}function n(){var e="undefined"!=typeof navigator.plugins&&"object"==typeof navigator.plugins["Shockwave Flash"];return e||(e=window.ActiveXObject&&new ActiveXObject("ShockwaveFlash.ShockwaveFlash")),e}function a(e){return"video/x-flv"===e||"video/x-f4v"===e||"video/f4v"===e||"application/x-shockwave-flash"===e}function o(e){return"application/javascript"===e||"application/x-javascript"===e}function i(){var e=/iphone/i.test(navigator.userAgent.toLowerCase());return e}function s(){var e=i()||/ipad/i.test(navigator.userAgent.toLowerCase());return e}function u(){return/android/i.test(navigator.userAgent.toLowerCase())}e.exports={supportsFlash:function(){return!t()&&n()},isBrowserOnMobile:function(){return t()},getBrowserName:function(){var e,r=navigator.userAgent,t=r.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i)||[];return/trident/i.test(t[1])?(e=/\brv[ :]+(\d+)/g.exec(r)||[],"IE"):"Chrome"===t[1]&&(e=r.match(/\bOPR\/(\d+)/),null!==e)?"Opera":(t=t[2]?[t[1],t[2]]:[navigator.appName,navigator.appVersion,"-?"],null!==(e=r.match(/version\/(\d+)/i))&&t.splice(1,1,e[1]),t[0])},canPlay:function(e,r){if(a(e.toLowerCase()))return!t()&&n();if(o(e.toLowerCase()))return!0;var i=e.toLowerCase();if(!r||""===r)if("video/mp4"===i)r="avc1.42E01E,mp4a.40.2";else if("video/webm"===i)r="vp8,vorbis";else{if("video/ogg"!==i)return!1;r="theora,vorbis"}var s=document.createElement("video"),u=s.canPlayType(i+';codecs="'+r+'"');return"probably"===u||"maybe"===u&&"video/webm"===i},getPlatformType:function(){return t()?u()?"mobile-Android":s()?"mobile-iOS":"mobile-unknown":n()?"desktop-flash":"desktop-no-flash"}}}]);